"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _webinyPlugins = require("webiny-plugins");

test("plugins - registerPlugins, unregisterPlugin, getPlugin, getPlugins",
/*#__PURE__*/
(0, _asyncToGenerator2.default)(
/*#__PURE__*/
_regenerator.default.mark(function _callee() {
  return _regenerator.default.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          (0, _webinyPlugins.registerPlugins)({
            type: "test",
            name: "test-1"
          }, [{
            type: "test",
            name: "test-2"
          }, {
            type: "test",
            name: "test-3"
          }, [{
            type: "test",
            name: "test-5"
          }, {
            type: "test",
            name: "test-6"
          }, [{
            type: "test",
            name: "test-7"
          }]]], {
            _name: "test-4",
            name: "Something...",
            type: "test"
          });
          expect((0, _webinyPlugins.getPlugins)().length).toBe(7);
          expect((0, _webinyPlugins.getPlugins)("test").length).toBe(7);
          expect((0, _webinyPlugins.getPlugins)("testXYZ").length).toBe(0);
          expect((0, _webinyPlugins.getPlugin)("test-1")).toEqual({
            type: "test",
            name: "test-1"
          });
          expect((0, _webinyPlugins.getPlugin)("test-2")).toEqual({
            type: "test",
            name: "test-2"
          });
          expect((0, _webinyPlugins.getPlugin)("test-3")).toEqual({
            type: "test",
            name: "test-3"
          });
          (0, _webinyPlugins.unregisterPlugin)("test-3");
          expect((0, _webinyPlugins.getPlugins)().length).toBe(6);
          expect((0, _webinyPlugins.getPlugins)("test").length).toBe(6);
          expect((0, _webinyPlugins.getPlugins)("testXYZ").length).toBe(0);
          expect((0, _webinyPlugins.getPlugin)("test-1")).toEqual({
            type: "test",
            name: "test-1"
          });
          expect((0, _webinyPlugins.getPlugin)("test-2")).toEqual({
            type: "test",
            name: "test-2"
          });
          expect((0, _webinyPlugins.getPlugin)("test-4")).toEqual({
            type: "test",
            name: "Something...",
            _name: "test-4"
          });
          expect((0, _webinyPlugins.getPlugin)("test-3")).toEqual(undefined);

        case 15:
        case "end":
          return _context.stop();
      }
    }
  }, _callee);
})));
test("plugins - registerPlugins, unregisterPlugin, getPlugin, getPlugins",
/*#__PURE__*/
(0, _asyncToGenerator2.default)(
/*#__PURE__*/
_regenerator.default.mark(function _callee2() {
  return _regenerator.default.wrap(function _callee2$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          _context2.prev = 0;
          (0, _webinyPlugins.registerPlugins)({
            type: "test",
            __name: "test-1",
            namE: "test-1"
          });
          _context2.next = 7;
          break;

        case 4:
          _context2.prev = 4;
          _context2.t0 = _context2["catch"](0);
          return _context2.abrupt("return");

        case 7:
          throw Error("Error should've been thrown.");

        case 8:
        case "end":
          return _context2.stop();
      }
    }
  }, _callee2, null, [[0, 4]]);
})));
test("plugins - if present, \"init\" method must be executed upon adding",
/*#__PURE__*/
(0, _asyncToGenerator2.default)(
/*#__PURE__*/
_regenerator.default.mark(function _callee3() {
  var initialized;
  return _regenerator.default.wrap(function _callee3$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          initialized = false;
          (0, _webinyPlugins.registerPlugins)({
            type: "test",
            name: "test-1",
            init: function init() {
              return initialized = true;
            }
          });
          expect(initialized).toBe(true);

        case 3:
        case "end":
          return _context3.stop();
      }
    }
  }, _callee3);
})));
//# sourceMappingURL=plugins.test.js.map