"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.unregisterPlugin = exports.getPlugin = exports.getPlugins = exports.registerPlugins = void 0;
var __plugins = {};

var _register = function _register(plugins) {
  for (var i = 0; i < plugins.length; i++) {
    var plugin = plugins[i];

    if (Array.isArray(plugin)) {
      _register(plugin);

      continue;
    }

    var name = plugin._name || plugin.name;

    if (!name) {
      throw Error("Plugin must have a \"name\" or \"_name\" key.");
    }

    __plugins[name] = plugin;
    plugin.init && plugin.init();
  }
};

var registerPlugins = function registerPlugins() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  return _register(args);
};

exports.registerPlugins = registerPlugins;

var getPlugins = function getPlugins(type) {
  var values = Object.values(__plugins);
  return values.filter(function (plugin) {
    return type ? plugin.type === type : true;
  });
};

exports.getPlugins = getPlugins;

var getPlugin = function getPlugin(name) {
  return __plugins[name];
};

exports.getPlugin = getPlugin;

var unregisterPlugin = function unregisterPlugin(name) {
  delete __plugins[name];
};

exports.unregisterPlugin = unregisterPlugin;
//# sourceMappingURL=index.js.map